package edu.stanford.db.rdf.syntax.strawman;

import org.w3c.rdf.model.*;
import edu.stanford.db.xml.util.Element;
import org.w3c.rdf.util.RDFUtil;
import java.util.*;

public class StrawElement extends Element {

  /**
   * subject URI of this node
   */
  Resource subject;
  boolean anonymous = false;

  /**
   * for ordered children
   */
  int counter = 0;

  /**
   * arcs going out from this node/subject URI
   * Once an arc is processed it is deleted from the vector
   */
  Vector arcs = new Vector(); // of StrawArcs

  /**
   * total number of arcs seen
   */
  //  int totalArcs = 0;

  /**
   * arc leading to this node from parent
   */
  Resource arcFromParent;

  /**
   * digest of the path from the root
   * When this node is fully processed, and is anonymous, this variable contains the digest of the node
   */
  byte[] digestPath;

  /**
   * depth from the root
   */
  int depth;

  /**
   * object must be RDFNode or StrawElement
   */
  void addArc(Resource predicate, Object object) {

      // System.err.println("---Adding arc to " + getName() + ": " + predicate + "->" + object);
    arcs.addElement(new StrawArc(predicate, object));
    //    totalArcs++;
  }

  int next() {
    return ++counter;
  }

  public String toString() {
    return "[ELEMENT " + getName() + "]";
  }

}
